/*
 * MiconoWiiChuckPrint 
 *
 * 2009/09/25 Micono Utilities
 *
 */

// Adopt the serial library
import processing.serial.*;

// Prepare the instance for the serial
Serial myPort;

// Prepare for variable font font
PFont font;

// Prepare variables for the Wii Nunchuk data
int accx=0;// Acceleration sensor
int accy=0;
int accz=0;
int zbut=0;// Button
int cbut=0;
int joyx=0;// Joystick
int joyy=0;

void setup(){
// Size of screen
  size(400,400);
// Load the font
  font = loadFont("Osaka-Mono-12.vlw");
// Start using font size: 12
  textFont(font, 12);
// Set the serial port
  myPort=new Serial(this,"COM8",19200);
  myPort.clear();
// To invoke () serialEvent
  myPort.bufferUntil(10);
}

void draw(){
// Background
  background(240);
// Display the value of the acceleration sensor
  fill(0); text("Acc-X:",10, 20); text(accx,50, 20); fill(255,0,0); rect(100,10,accx,8);
  fill(0); text("Acc-Y:",10, 40); text(accy,50, 40); fill(0,255,0); rect(100,30,accy,8);
  fill(0); text("Acc-Z:",10, 60); text(accz,50, 60); fill(0,0,255); rect(100,50,accz,8);
// On / off button
  fill(0); text("C-but:",10, 80); //text(cbut,50, 80);
  if(cbut==1) {
    fill(0,0,255);  
    text("ON",50,80);
  } else {
    fill(255,0,0);
    text("OFF",50,80);
  }
  fill(0); text("Z-but:",10,100); //text(zbut,50,100);
  if(zbut==1) {
    fill(0,0,255); 
    text("ON",50,100);
  } else {
    fill(255,0,0);
    text("OFF",50,100);
  }
  
// Display the value of a joystick
  fill(0); 
  text("Joy-X:",10,120); text(joyx,50,120);
  text("Joy-Y:",10,140); text(joyy,50,140);
  rectMode(CORNER);
  fill(180);
  rect(100,100,256,256);
  fill(255,255,0);
  ellipse(100+joyx,356-joyy,16,16);
}

// Serial communication processing
void serialEvent(Serial p){
// The data has been sent from the Arduino
// Prepare a string variable stringData,
// "10" until it is read (line feed)
  String stringData=myPort.readStringUntil(10);
  
// When the data string is not empty
  if(stringData!=null){
// Get rid of the newline character that is included in the data string
    stringData=trim(stringData);
// Prepare an array of integer type data [],
// Separated by a comma symbol string data based on
// Keep the data to an integer array to []

    int data[]=int(split(stringData,','));
    
// Data in the data array [] If the seven
    if(data.length==7){
      accx=data[0];
      accy=data[1];
      accz=data[2];
      zbut=data[3];
      cbut=data[4];
      joyx=data[5];
      joyy=data[6];
    }
  }
}


